package addbk.midtermAddressBook;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Use the adapter design patter to alter the interface from ActionListener
 * to Runnable. Use the command pattern by creating anonymous inner classes
 * to embed implementations of the runnable interface.
 */
public class Menu
    extends JMenuBar
    implements ActionListener {
  AddressBookMediator abm = new AddressBookMediator();

  public Menu() {
    JMenu jMenu = new JMenu("File");
    jMenu.setMnemonic(KeyEvent.VK_F); // Set Mnemonic.
    this.add(jMenu);
    JMenuItem itemOpenCSV = new JMenuItem("Open CSV");
    itemOpenCSV.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
        ActionEvent.ALT_MASK));
    itemOpenCSV.setMnemonic(KeyEvent.VK_O);
    jMenu.add(itemOpenCSV);
    itemOpenCSV.addActionListener(this);

    JMenuItem itemSaveAsCSV = new JMenuItem("Save as CSV");
    itemSaveAsCSV.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,
        ActionEvent.ALT_MASK));
    itemSaveAsCSV.setMnemonic(KeyEvent.VK_V);
    jMenu.add(itemSaveAsCSV);
    itemSaveAsCSV.addActionListener(this);

    JMenuItem itemOpenXML = new JMenuItem("Open XML");
    itemOpenXML.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,
        ActionEvent.ALT_MASK));
    itemOpenXML.setMnemonic(KeyEvent.VK_E);
    jMenu.add(itemOpenXML);
    itemOpenXML.addActionListener(this);

    JMenuItem itemSaveAsXML = new JMenuItem("Save as XML");
    itemSaveAsXML.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M,
        ActionEvent.ALT_MASK));
    itemSaveAsXML.setMnemonic(KeyEvent.VK_M);
    jMenu.add(itemSaveAsXML);
    itemSaveAsXML.addActionListener(this);

    JMenuItem itemMergeFromCSV = new JMenuItem("Merge from CSV");
    itemMergeFromCSV.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_G,
        ActionEvent.ALT_MASK));
    itemMergeFromCSV.setMnemonic(KeyEvent.VK_G);
    jMenu.add(itemMergeFromCSV);
    itemMergeFromCSV.addActionListener(this);

    JMenuItem itemMergeFromXML = new JMenuItem("Merge from XML");
    itemMergeFromXML.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L,
        ActionEvent.ALT_MASK));
    itemMergeFromXML.setMnemonic(KeyEvent.VK_L);
    jMenu.add(itemMergeFromXML);
    itemMergeFromXML.addActionListener(this);

    JMenuItem itemExit = new JMenuItem("Exit");
    itemExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,
        ActionEvent.ALT_MASK));
    itemExit.setMnemonic(KeyEvent.VK_X);
    jMenu.add(itemExit);
    itemExit.addActionListener(this);
  }

  public void actionPerformed(ActionEvent e) {
    JMenuItem source = (JMenuItem) (e.getSource());
    String text = source.getText();
    if (text.equals("Open CSV")) {
      CSVReader reader = new CSVReader();
      abm.setAbc(reader.CSVReader()); // Clear the abc object and load the new object.
      abm.getAbc().setRecordNumber(0); // Position = 0.
    }
    else if (text.equals("Save as CSV")) {
      CSVWriter writer = new CSVWriter(abm.getAbc());
    }
    else if (text.equals("Open XML")) {
      XMLReader reader = new XMLReader();
      abm.setAbc(reader.open());
      abm.getAbc().setRecordNumber(0); // Position = 0.
    }
    else if (text.equals("Save as XML")) {
      XMLWriter xmlWriter = new XMLWriter(abm.getAbc());
    }
    else if (text.equals("Merge from CSV")) {
      CSVReader reader = new CSVReader();
      abm.mergeCollection(reader.CSVReader());
      abm.getAbc().setRecordNumber(0); // Position = 0

    }
    else if (text.equals("Merge from XML")) {
      XMLReader reader = new XMLReader();
            abm.mergeCollection(reader.open());
            abm.getAbc().setRecordNumber(0); // Position = 0

    }
    else if (text.equals("Exit")) {
      System.exit(0); // Exit the program.
    }

  }
}
